/*
 * Demo-Programm zum Gebrauch der "Nav XCMD"
 *
 */

#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <tos.h>
#include "mgmc_api.h"
#include "nav_xcmd.h"


/* Cookie structure */

typedef struct {
	long		key;
	long		value;
} COOKIE;

/*********************************************************************
*
* Ermittelt einen Cookie
*
*********************************************************************/

COOKIE *getcookie(long key)
{
	return((COOKIE *) xbios(39, 'AnKr', 4, key));
}


/*********************************************************************
*
* Zeigt einen Navigation-Dialog
*
*********************************************************************/

int main (void)
{
	COOKIE *cookie;
	MgMcCookie *gMgMcCookie;
	XCMDMgrRec *xcmd;
	XCMDHdl hdl;
	NGetFileParm gparm;
	NPutFileParm pparm;
	char buf[256];
	long ret;



	cookie = getcookie('MgMc');
	if	(!cookie)
		return(-1);

	gMgMcCookie = (MgMcCookie *) cookie->value; 
	
	/* find and open the XCMD */

	xcmd = gMgMcCookie->xcmdMgrPtr;
	if	(!xcmd)
		return(-1);

	/* NAV XCMD */

	Cconws("Navigation Services laden...\r\n");
	hdl = xcmd->open("Nav XCMD");

	if	((long)hdl < 0)
		return(-1);		/* Nav XCMD ist nicht installiert */

	gparm.buflen = 256;
	gparm.buf = buf;
	Cconws("Bestehende Datei auswhlen...\r\n");
	ret = xcmd->call (hdl, xcmdGetFile, &gparm);

	if	(!ret)
		{
		Cconws("Pfad = \"");
		Cconws(buf);
		Cconws("\"");
		}
	else	{
		if	(ret == 1)
			Cconws("Es wurde kein Objekt ausgewhlt.");
		else	{
			ltoa(ret, buf, 10);
			Cconws("Fehlercode ");
			Cconws(buf);
			}
		}
	Cconws("\r\n");
	Cconin();

	pparm.buflen = 256;
	pparm.buf = buf;
	Cconws("Sichern: Neue Datei anwhlen...\r\n");
	ret = xcmd->call (hdl, xcmdPutFile, &pparm);

	if	(!ret)
		{
		Cconws("Pfad = \"");
		Cconws(buf);
		Cconws("\"");
		}
	else	{
		if	(ret == 1)
			Cconws("Es wurde kein Objekt ausgewhlt.");
		else	{
			ltoa(ret, buf, 10);
			Cconws("Fehlercode ");
			Cconws(buf);
			}
		}
	Cconws("\r\n");
	Cconin();

	Cconws("Navigation Services freigeben...\r\n");
	xcmd->close (hdl);

	return(0);
}
